/*
 * Copyright (C) 2024  Fluence DAO
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import { IFluenceClient } from "@fluencelabs/js-client";
import {
  errorClearTest,
  registerFailService,
} from "../compiled/examples/errorClear.js";

export async function errorClearCall(peer: IFluenceClient) {
  registerFailService(peer, {
    call: (s: string) => {
      if (s === "fail") return Promise.reject(s);
      else return Promise.resolve(s);
    },
  });

  return await errorClearTest(peer.getPeerId(), peer.getRelayPeerId());
}
